import{S as Gl,i as Rl,s as Wl,e as o,k as i,w as $,t as a,M as Vl,c as n,d as t,m as p,a as l,x as v,h as r,b as T,G as e,g as j,y as b,q as E,o as w,B as y,v as zl,L as Oe}from"../../chunks/vendor-hf-doc-builder.js";import{D as I}from"../../chunks/Docstring-hf-doc-builder.js";import{C as Le}from"../../chunks/CodeBlock-hf-doc-builder.js";import{I as Ul}from"../../chunks/IconCopyLink-hf-doc-builder.js";import{E as De}from"../../chunks/ExampleCodeBlock-hf-doc-builder.js";function Bl(O){let d,u,f,h,g;return h=new Le({props:{code:`from accelerate.state import PartialState

state = PartialState()
with state.local_main_process_first():
    # This will be printed first by local process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {state.local_process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

<span class="hljs-meta">&gt;&gt;&gt; </span>state = PartialState()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> state.local_main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by local process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{state.local_process_index}</span>&quot;</span>)`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Ml(O){let d,u,f,h,g;return h=new Le({props:{code:`from accelerate import Accelerator

accelerator = Accelerator()
with accelerator.main_process_first():
    # This will be printed first by process 0 then in a seemingly
    # random order by the other processes.
    print(f"This will be printed by process {accelerator.process_index}")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

<span class="hljs-meta">&gt;&gt;&gt; </span>accelerator = Accelerator()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">with</span> accelerator.main_process_first():
<span class="hljs-meta">... </span>    <span class="hljs-comment"># This will be printed first by process 0 then in a seemingly</span>
<span class="hljs-meta">... </span>    <span class="hljs-comment"># random order by the other processes.</span>
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;This will be printed by process <span class="hljs-subst">{accelerator.process_index}</span>&quot;</span>)`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Fl(O){let d,u,f,h,g;return h=new Le({props:{code:`# Assume we have 4 processes.
from accelerate.state import PartialState

state = PartialState()


@state.on_last_process
def print_something():
    print(f"Printed on process {state.process_index}")


print_something()
"Printed on process 3"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

state = PartialState()


<span class="hljs-meta">@state.on_last_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{state.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 3&quot;</span>`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Hl(O){let d,u,f,h,g;return h=new Le({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate.state import PartialState

state = PartialState()


@state.on_local_main_process
def print_something():
    print("This will be printed by process 0 only on each server.")


print_something()
# On server 1:
"This will be printed by process 0 only"
# On server 2:
"This will be printed by process 0 only"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

state = PartialState()


<span class="hljs-meta">@state.on_local_main_process</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only on each server.&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Jl(O){let d,u,f,h,g;return h=new Le({props:{code:`# Assume we have 2 servers with 4 processes each.
from accelerate import Accelerator

accelerator = Accelerator()


@accelerator.on_local_process(local_process_index=2)
def print_something():
    print(f"Printed on process {accelerator.local_process_index}")


print_something()
# On server 1:
"Printed on process 2"
# On server 2:
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 2 servers with 4 processes each.</span>
<span class="hljs-keyword">from</span> accelerate <span class="hljs-keyword">import</span> Accelerator

accelerator = Accelerator()


<span class="hljs-meta">@accelerator.on_local_process(<span class="hljs-params">local_process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{accelerator.local_process_index}</span>&quot;</span>)


print_something()
<span class="hljs-comment"># On server 1:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>
<span class="hljs-comment"># On server 2:</span>
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Kl(O){let d,u,f,h,g;return h=new Le({props:{code:`from accelerate.state import PartialState

state = PartialState()


@state.on_main_process
def print_something():
    print("This will be printed by process 0 only.")


print_something()`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

<span class="hljs-meta">&gt;&gt;&gt; </span>state = PartialState()


<span class="hljs-meta">&gt;&gt;&gt; </span>@state.on_main_process
<span class="hljs-meta">... </span><span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;This will be printed by process 0 only.&quot;</span>)


<span class="hljs-meta">&gt;&gt;&gt; </span>print_something()
<span class="hljs-string">&quot;This will be printed by process 0 only&quot;</span>`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Ql(O){let d,u,f,h,g;return h=new Le({props:{code:`# Assume we have 4 processes.
from accelerate.state import PartialState

state = PartialState()


@state.on_process(process_index=2)
def print_something():
    print(f"Printed on process {state.process_index}")


print_something()
"Printed on process 2"`,highlighted:`<span class="hljs-comment"># Assume we have 4 processes.</span>
<span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

state = PartialState()


<span class="hljs-meta">@state.on_process(<span class="hljs-params">process_index=<span class="hljs-number">2</span></span>)</span>
<span class="hljs-keyword">def</span> <span class="hljs-title function_">print_something</span>():
    <span class="hljs-built_in">print</span>(<span class="hljs-string">f&quot;Printed on process <span class="hljs-subst">{state.process_index}</span>&quot;</span>)


print_something()
<span class="hljs-string">&quot;Printed on process 2&quot;</span>`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Xl(O){let d,u,f,h,g;return h=new Le({props:{code:`# Assuming two GPU processes
import time
from accelerate.state import PartialState

state = PartialState()
if state.is_main_process:
    time.sleep(2)
else:
    print("I'm waiting for the main process to finish its sleep...")
state.wait_for_everyone()
# Should print on every process at the same time
print("Everyone is here")`,highlighted:`<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Assuming two GPU processes</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">import</span> time
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">from</span> accelerate.state <span class="hljs-keyword">import</span> PartialState

<span class="hljs-meta">&gt;&gt;&gt; </span>state = PartialState()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">if</span> state.is_main_process:
<span class="hljs-meta">... </span>    time.sleep(<span class="hljs-number">2</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-keyword">else</span>:
<span class="hljs-meta">... </span>    <span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;I&#x27;m waiting for the main process to finish its sleep...&quot;</span>)
<span class="hljs-meta">&gt;&gt;&gt; </span>state.wait_for_everyone()
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-comment"># Should print on every process at the same time</span>
<span class="hljs-meta">&gt;&gt;&gt; </span><span class="hljs-built_in">print</span>(<span class="hljs-string">&quot;Everyone is here&quot;</span>)`}}),{c(){d=o("p"),u=a("Example:"),f=i(),$(h.$$.fragment)},l(s){d=n(s,"P",{});var m=l(d);u=r(m,"Example:"),m.forEach(t),f=p(s),v(h.$$.fragment,s)},m(s,m){j(s,d,m),e(d,u),j(s,f,m),b(h,s,m),g=!0},p:Oe,i(s){g||(E(h.$$.fragment,s),g=!0)},o(s){w(h.$$.fragment,s),g=!1},d(s){s&&t(d),s&&t(f),y(h,s)}}}function Yl(O){let d,u,f,h,g,s,m,ct,ta,Ks,X,sa,Ae,aa,ra,Qs,Ke,oa,Xs,x,Ce,na,J,la,it,ca,ia,pt,pa,ha,da,ht,dt,ma,fa,k,Y,mt,ga,ua,ft,_a,$a,va,Z,gt,ba,Ea,Qe,wa,ya,xa,ee,ut,ja,Sa,_t,Pa,Ta,ka,te,$t,Da,Oa,vt,La,Aa,Ca,se,bt,Ia,Na,Et,qa,Ga,Ra,ae,wt,Wa,Va,yt,za,Ua,Ba,re,xt,Ma,Fa,jt,Ha,Ja,Ka,oe,St,Qa,Xa,Pt,Ya,Za,er,ne,Tt,tr,sr,kt,ar,rr,or,N,Ie,nr,Dt,lr,cr,Ot,ir,pr,le,hr,q,Ne,dr,Lt,mr,fr,At,gr,ur,ce,_r,W,qe,$r,Ct,vr,br,ie,Er,V,Ge,wr,It,yr,xr,pe,jr,z,Re,Sr,Nt,Pr,Tr,he,kr,U,We,Dr,qt,Or,Lr,de,Ar,B,Ve,Cr,Gt,Ir,Nr,me,qr,M,ze,Gr,Rt,Rr,Wr,fe,Ys,A,Ue,Vr,Wt,zr,Ur,Vt,zt,Br,Mr,P,ge,Ut,Fr,Hr,Bt,Jr,Kr,Qr,ue,Mt,Xr,Yr,Xe,Zr,eo,to,G,Ft,so,ao,Ht,ro,oo,Jt,no,lo,Kt,co,io,po,_e,Qt,ho,mo,Xt,fo,go,uo,$e,Yt,_o,$o,Zt,vo,bo,Eo,ve,es,wo,yo,ts,xo,jo,So,be,ss,Po,To,as,ko,Do,Oo,Ee,rs,Lo,Ao,os,Co,Io,No,we,ns,qo,Go,ls,Ro,Wo,Vo,ye,cs,zo,Uo,is,Bo,Mo,Fo,F,Be,Ho,ps,Jo,Ko,hs,Qo,Xo,H,Me,Yo,ds,Zo,en,ms,tn,Zs,C,Fe,sn,fs,an,rn,gs,us,on,nn,K,xe,_s,ln,cn,$s,pn,hn,dn,je,vs,mn,fn,bs,gn,un,_n,Se,Es,$n,vn,ws,bn,En,ea;return s=new Ul({}),Ce=new I({props:{name:"class accelerate.PartialState",anchor:"accelerate.PartialState",parameters:[{name:"cpu",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L56"}}),Ie=new I({props:{name:"local_main_process_first",anchor:"accelerate.PartialState.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L318"}}),le=new De({props:{anchor:"accelerate.PartialState.local_main_process_first.example",$$slots:{default:[Bl]},$$scope:{ctx:O}}}),Ne=new I({props:{name:"main_process_first",anchor:"accelerate.PartialState.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L297"}}),ce=new De({props:{anchor:"accelerate.PartialState.main_process_first.example",$$slots:{default:[Ml]},$$scope:{ctx:O}}}),qe=new I({props:{name:"on_last_process",anchor:"accelerate.PartialState.on_last_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any]"}],parametersDescription:[{anchor:"accelerate.PartialState.on_last_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L400"}}),ie=new De({props:{anchor:"accelerate.PartialState.on_last_process.example",$$slots:{default:[Fl]},$$scope:{ctx:O}}}),Ge=new I({props:{name:"on_local_main_process",anchor:"accelerate.PartialState.on_local_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_local_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L369"}}),pe=new De({props:{anchor:"accelerate.PartialState.on_local_main_process.example",$$slots:{default:[Hl]},$$scope:{ctx:O}}}),Re=new I({props:{name:"on_local_process",anchor:"accelerate.PartialState.on_local_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"local_process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_local_process.function",description:`<strong>function</strong> (<code>Callable</code>, <em>optional</em>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.PartialState.on_local_process.local_process_index",description:`<strong>local_process_index</strong> (<code>int</code>, <em>optional</em>) &#x2014;
The index of the local process on which to run the function.`,name:"local_process_index"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L461"}}),he=new De({props:{anchor:"accelerate.PartialState.on_local_process.example",$$slots:{default:[Jl]},$$scope:{ctx:O}}}),We=new I({props:{name:"on_main_process",anchor:"accelerate.PartialState.on_main_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_main_process.function",description:"<strong>function</strong> (<code>Callable</code>) &#x2014; The function to decorate.",name:"function"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L339"}}),de=new De({props:{anchor:"accelerate.PartialState.on_main_process.example",$$slots:{default:[Kl]},$$scope:{ctx:O}}}),Ve=new I({props:{name:"on_process",anchor:"accelerate.PartialState.on_process",parameters:[{name:"function",val:": typing.Callable[..., typing.Any] = None"},{name:"process_index",val:": int = None"}],parametersDescription:[{anchor:"accelerate.PartialState.on_process.function",description:`<strong>function</strong> (<code>Callable</code>, <code>optional</code>) &#x2014;
The function to decorate.`,name:"function"},{anchor:"accelerate.PartialState.on_process.process_index",description:`<strong>process_index</strong> (<code>int</code>, <code>optional</code>) &#x2014;
The index of the process on which to run the function.`,name:"process_index"}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L428"}}),me=new De({props:{anchor:"accelerate.PartialState.on_process.example",$$slots:{default:[Ql]},$$scope:{ctx:O}}}),ze=new I({props:{name:"wait_for_everyone",anchor:"accelerate.PartialState.wait_for_everyone",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L256"}}),fe=new De({props:{anchor:"accelerate.PartialState.wait_for_everyone.example",$$slots:{default:[Xl]},$$scope:{ctx:O}}}),Ue=new I({props:{name:"class accelerate.state.AcceleratorState",anchor:"accelerate.state.AcceleratorState",parameters:[{name:"mixed_precision",val:": str = None"},{name:"cpu",val:": bool = False"},{name:"dynamo_plugin",val:" = None"},{name:"deepspeed_plugin",val:" = None"},{name:"fsdp_plugin",val:" = None"},{name:"megatron_lm_plugin",val:" = None"},{name:"_from_accelerator",val:": bool = False"},{name:"**kwargs",val:""}],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L502"}}),Be=new I({props:{name:"local_main_process_first",anchor:"accelerate.state.AcceleratorState.local_main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L675"}}),Me=new I({props:{name:"main_process_first",anchor:"accelerate.state.AcceleratorState.main_process_first",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L666"}}),Fe=new I({props:{name:"class accelerate.state.GradientState",anchor:"accelerate.state.GradientState",parameters:[],source:"https://github.com/huggingface/accelerate/blob/v0.17.0/src/accelerate/state.py#L688"}}),{c(){d=o("meta"),u=i(),f=o("h1"),h=o("a"),g=o("span"),$(s.$$.fragment),m=i(),ct=o("span"),ta=a("Stateful Classes"),Ks=i(),X=o("p"),sa=a("Below are variations of a "),Ae=o("a"),aa=a("singleton class"),ra=a(` in the sense that all
instances share the same state, which is initialized on the first instantiation.`),Qs=i(),Ke=o("p"),oa=a(`These classes are immutable and store information about certain configurations or
states.`),Xs=i(),x=o("div"),$(Ce.$$.fragment),na=i(),J=o("p"),la=a(`Singleton class that has information about the current training environment and functions to help with process
control. Designed to be used when only process control and device execution states are needed. Does `),it=o("em"),ca=a("not"),ia=a(` need to
be initialized from `),pt=o("code"),pa=a("Accelerator"),ha=a("."),da=i(),ht=o("p"),dt=o("strong"),ma=a("Available attributes:"),fa=i(),k=o("ul"),Y=o("li"),mt=o("strong"),ga=a("device"),ua=a(" ("),ft=o("code"),_a=a("torch.device"),$a=a(") \u2014 The device to use."),va=i(),Z=o("li"),gt=o("strong"),ba=a("distributed_type"),Ea=a(" ("),Qe=o("a"),wa=a("DistributedType"),ya=a(`) \u2014 The type of distributed environment currently
in use.`),xa=i(),ee=o("li"),ut=o("strong"),ja=a("local_process_index"),Sa=a(" ("),_t=o("code"),Pa=a("int"),Ta=a(") \u2014 The index of the current process on the current server."),ka=i(),te=o("li"),$t=o("strong"),Da=a("mixed_precision"),Oa=a(" ("),vt=o("code"),La=a("str"),Aa=a(`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Ca=i(),se=o("li"),bt=o("strong"),Ia=a("num_processes"),Na=a(" ("),Et=o("code"),qa=a("int"),Ga=a(") \u2014 The number of processes currently launched in parallel."),Ra=i(),ae=o("li"),wt=o("strong"),Wa=a("process_index"),Va=a(" ("),yt=o("code"),za=a("int"),Ua=a(") \u2014 The index of the current process."),Ba=i(),re=o("li"),xt=o("strong"),Ma=a("is_last_process"),Fa=a(" ("),jt=o("code"),Ha=a("bool"),Ja=a(") \u2014 Whether or not the current process is the last one."),Ka=i(),oe=o("li"),St=o("strong"),Qa=a("is_main_process"),Xa=a(" ("),Pt=o("code"),Ya=a("bool"),Za=a(") \u2014 Whether or not the current process is the main one."),er=i(),ne=o("li"),Tt=o("strong"),tr=a("is_local_main_process"),sr=a(" ("),kt=o("code"),ar=a("bool"),rr=a(") \u2014 Whether or not the current process is the main one on the local node."),or=i(),N=o("div"),$(Ie.$$.fragment),nr=i(),Dt=o("p"),lr=a("Lets the local main process go inside a with block."),cr=i(),Ot=o("p"),ir=a("The other processes will enter the with block after the main process exits."),pr=i(),$(le.$$.fragment),hr=i(),q=o("div"),$(Ne.$$.fragment),dr=i(),Lt=o("p"),mr=a("Lets the main process go first inside a with block."),fr=i(),At=o("p"),gr=a("The other processes will enter the with block after the main process exits."),ur=i(),$(ce.$$.fragment),_r=i(),W=o("div"),$(qe.$$.fragment),$r=i(),Ct=o("p"),vr=a("Decorator that only runs the decorated function on the last process."),br=i(),$(ie.$$.fragment),Er=i(),V=o("div"),$(Ge.$$.fragment),wr=i(),It=o("p"),yr=a("Decorator that only runs the decorated function on the local main process."),xr=i(),$(pe.$$.fragment),jr=i(),z=o("div"),$(Re.$$.fragment),Sr=i(),Nt=o("p"),Pr=a("Decorator that only runs the decorated function on the process with the given index on the current node."),Tr=i(),$(he.$$.fragment),kr=i(),U=o("div"),$(We.$$.fragment),Dr=i(),qt=o("p"),Or=a("Decorator that only runs the decorated function on the main process."),Lr=i(),$(de.$$.fragment),Ar=i(),B=o("div"),$(Ve.$$.fragment),Cr=i(),Gt=o("p"),Ir=a("Decorator that only runs the decorated function on the process with the given index."),Nr=i(),$(me.$$.fragment),qr=i(),M=o("div"),$(ze.$$.fragment),Gr=i(),Rt=o("p"),Rr=a(`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),Wr=i(),$(fe.$$.fragment),Ys=i(),A=o("div"),$(Ue.$$.fragment),Vr=i(),Wt=o("p"),zr=a("Singleton class that has information about the current training environment."),Ur=i(),Vt=o("p"),zt=o("strong"),Br=a("Available attributes:"),Mr=i(),P=o("ul"),ge=o("li"),Ut=o("strong"),Fr=a("device"),Hr=a(" ("),Bt=o("code"),Jr=a("torch.device"),Kr=a(") \u2014 The device to use."),Qr=i(),ue=o("li"),Mt=o("strong"),Xr=a("distributed_type"),Yr=a(" ("),Xe=o("a"),Zr=a("DistributedType"),eo=a(`) \u2014 The type of distributed environment currently
in use.`),to=i(),G=o("li"),Ft=o("strong"),so=a("initialized"),ao=a(" ("),Ht=o("code"),ro=a("bool"),oo=a(") \u2014 Whether or not the "),Jt=o("code"),no=a("AcceleratorState"),lo=a(" has been initialized from "),Kt=o("code"),co=a("Accelerator"),io=a("."),po=i(),_e=o("li"),Qt=o("strong"),ho=a("local_process_index"),mo=a(" ("),Xt=o("code"),fo=a("int"),go=a(") \u2014 The index of the current process on the current server."),uo=i(),$e=o("li"),Yt=o("strong"),_o=a("mixed_precision"),$o=a(" ("),Zt=o("code"),vo=a("str"),bo=a(`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Eo=i(),ve=o("li"),es=o("strong"),wo=a("num_processes"),yo=a(" ("),ts=o("code"),xo=a("int"),jo=a(") \u2014 The number of processes currently launched in parallel."),So=i(),be=o("li"),ss=o("strong"),Po=a("process_index"),To=a(" ("),as=o("code"),ko=a("int"),Do=a(") \u2014 The index of the current process."),Oo=i(),Ee=o("li"),rs=o("strong"),Lo=a("is_last_process"),Ao=a(" ("),os=o("code"),Co=a("bool"),Io=a(") \u2014 Whether or not the current process is the last one."),No=i(),we=o("li"),ns=o("strong"),qo=a("is_main_process"),Go=a(" ("),ls=o("code"),Ro=a("bool"),Wo=a(") \u2014 Whether or not the current process is the main one."),Vo=i(),ye=o("li"),cs=o("strong"),zo=a("is_local_main_process"),Uo=a(" ("),is=o("code"),Bo=a("bool"),Mo=a(") \u2014 Whether or not the current process is the main one on the local node."),Fo=i(),F=o("div"),$(Be.$$.fragment),Ho=i(),ps=o("p"),Jo=a("Lets the local main process go inside a with block."),Ko=i(),hs=o("p"),Qo=a("The other processes will enter the with block after the main process exits."),Xo=i(),H=o("div"),$(Me.$$.fragment),Yo=i(),ds=o("p"),Zo=a("Lets the main process go first inside a with block."),en=i(),ms=o("p"),tn=a("The other processes will enter the with block after the main process exits."),Zs=i(),C=o("div"),$(Fe.$$.fragment),sn=i(),fs=o("p"),an=a("Singleton class that has information related to gradient synchronization for gradient accumulation"),rn=i(),gs=o("p"),us=o("strong"),on=a("Available attributes:"),nn=i(),K=o("ul"),xe=o("li"),_s=o("strong"),ln=a("end_of_dataloader"),cn=a(" ("),$s=o("code"),pn=a("bool"),hn=a(") \u2014 Whether we have reached the end the current dataloader"),dn=i(),je=o("li"),vs=o("strong"),mn=a("remainder"),fn=a(" ("),bs=o("code"),gn=a("int"),un=a(") \u2014 The number of extra samples that were added from padding the dataloader"),_n=i(),Se=o("li"),Es=o("strong"),$n=a("sync_gradients"),vn=a(" ("),ws=o("code"),bn=a("bool"),En=a(") \u2014 Whether the gradients should be synced across all devices"),this.h()},l(c){const _=Vl('[data-svelte="svelte-1phssyn"]',document.head);d=n(_,"META",{name:!0,content:!0}),_.forEach(t),u=p(c),f=n(c,"H1",{class:!0});var He=l(f);h=n(He,"A",{id:!0,class:!0,href:!0});var ys=l(h);g=n(ys,"SPAN",{});var xs=l(g);v(s.$$.fragment,xs),xs.forEach(t),ys.forEach(t),m=p(He),ct=n(He,"SPAN",{});var js=l(ct);ta=r(js,"Stateful Classes"),js.forEach(t),He.forEach(t),Ks=p(c),X=n(c,"P",{});var Je=l(X);sa=r(Je,"Below are variations of a "),Ae=n(Je,"A",{href:!0,rel:!0});var Ss=l(Ae);aa=r(Ss,"singleton class"),Ss.forEach(t),ra=r(Je,` in the sense that all
instances share the same state, which is initialized on the first instantiation.`),Je.forEach(t),Qs=p(c),Ke=n(c,"P",{});var Ps=l(Ke);oa=r(Ps,`These classes are immutable and store information about certain configurations or
states.`),Ps.forEach(t),Xs=p(c),x=n(c,"DIV",{class:!0});var S=l(x);v(Ce.$$.fragment,S),na=p(S),J=n(S,"P",{});var Ye=l(J);la=r(Ye,`Singleton class that has information about the current training environment and functions to help with process
control. Designed to be used when only process control and device execution states are needed. Does `),it=n(Ye,"EM",{});var wn=l(it);ca=r(wn,"not"),wn.forEach(t),ia=r(Ye,` need to
be initialized from `),pt=n(Ye,"CODE",{});var yn=l(pt);pa=r(yn,"Accelerator"),yn.forEach(t),ha=r(Ye,"."),Ye.forEach(t),da=p(S),ht=n(S,"P",{});var xn=l(ht);dt=n(xn,"STRONG",{});var jn=l(dt);ma=r(jn,"Available attributes:"),jn.forEach(t),xn.forEach(t),fa=p(S),k=n(S,"UL",{});var L=l(k);Y=n(L,"LI",{});var Ts=l(Y);mt=n(Ts,"STRONG",{});var Sn=l(mt);ga=r(Sn,"device"),Sn.forEach(t),ua=r(Ts," ("),ft=n(Ts,"CODE",{});var Pn=l(ft);_a=r(Pn,"torch.device"),Pn.forEach(t),$a=r(Ts,") \u2014 The device to use."),Ts.forEach(t),va=p(L),Z=n(L,"LI",{});var ks=l(Z);gt=n(ks,"STRONG",{});var Tn=l(gt);ba=r(Tn,"distributed_type"),Tn.forEach(t),Ea=r(ks," ("),Qe=n(ks,"A",{href:!0});var kn=l(Qe);wa=r(kn,"DistributedType"),kn.forEach(t),ya=r(ks,`) \u2014 The type of distributed environment currently
in use.`),ks.forEach(t),xa=p(L),ee=n(L,"LI",{});var Ds=l(ee);ut=n(Ds,"STRONG",{});var Dn=l(ut);ja=r(Dn,"local_process_index"),Dn.forEach(t),Sa=r(Ds," ("),_t=n(Ds,"CODE",{});var On=l(_t);Pa=r(On,"int"),On.forEach(t),Ta=r(Ds,") \u2014 The index of the current process on the current server."),Ds.forEach(t),ka=p(L),te=n(L,"LI",{});var Os=l(te);$t=n(Os,"STRONG",{});var Ln=l($t);Da=r(Ln,"mixed_precision"),Ln.forEach(t),Oa=r(Os," ("),vt=n(Os,"CODE",{});var An=l(vt);La=r(An,"str"),An.forEach(t),Aa=r(Os,`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Os.forEach(t),Ca=p(L),se=n(L,"LI",{});var Ls=l(se);bt=n(Ls,"STRONG",{});var Cn=l(bt);Ia=r(Cn,"num_processes"),Cn.forEach(t),Na=r(Ls," ("),Et=n(Ls,"CODE",{});var In=l(Et);qa=r(In,"int"),In.forEach(t),Ga=r(Ls,") \u2014 The number of processes currently launched in parallel."),Ls.forEach(t),Ra=p(L),ae=n(L,"LI",{});var As=l(ae);wt=n(As,"STRONG",{});var Nn=l(wt);Wa=r(Nn,"process_index"),Nn.forEach(t),Va=r(As," ("),yt=n(As,"CODE",{});var qn=l(yt);za=r(qn,"int"),qn.forEach(t),Ua=r(As,") \u2014 The index of the current process."),As.forEach(t),Ba=p(L),re=n(L,"LI",{});var Cs=l(re);xt=n(Cs,"STRONG",{});var Gn=l(xt);Ma=r(Gn,"is_last_process"),Gn.forEach(t),Fa=r(Cs," ("),jt=n(Cs,"CODE",{});var Rn=l(jt);Ha=r(Rn,"bool"),Rn.forEach(t),Ja=r(Cs,") \u2014 Whether or not the current process is the last one."),Cs.forEach(t),Ka=p(L),oe=n(L,"LI",{});var Is=l(oe);St=n(Is,"STRONG",{});var Wn=l(St);Qa=r(Wn,"is_main_process"),Wn.forEach(t),Xa=r(Is," ("),Pt=n(Is,"CODE",{});var Vn=l(Pt);Ya=r(Vn,"bool"),Vn.forEach(t),Za=r(Is,") \u2014 Whether or not the current process is the main one."),Is.forEach(t),er=p(L),ne=n(L,"LI",{});var Ns=l(ne);Tt=n(Ns,"STRONG",{});var zn=l(Tt);tr=r(zn,"is_local_main_process"),zn.forEach(t),sr=r(Ns," ("),kt=n(Ns,"CODE",{});var Un=l(kt);ar=r(Un,"bool"),Un.forEach(t),rr=r(Ns,") \u2014 Whether or not the current process is the main one on the local node."),Ns.forEach(t),L.forEach(t),or=p(S),N=n(S,"DIV",{class:!0});var Pe=l(N);v(Ie.$$.fragment,Pe),nr=p(Pe),Dt=n(Pe,"P",{});var Bn=l(Dt);lr=r(Bn,"Lets the local main process go inside a with block."),Bn.forEach(t),cr=p(Pe),Ot=n(Pe,"P",{});var Mn=l(Ot);ir=r(Mn,"The other processes will enter the with block after the main process exits."),Mn.forEach(t),pr=p(Pe),v(le.$$.fragment,Pe),Pe.forEach(t),hr=p(S),q=n(S,"DIV",{class:!0});var Te=l(q);v(Ne.$$.fragment,Te),dr=p(Te),Lt=n(Te,"P",{});var Fn=l(Lt);mr=r(Fn,"Lets the main process go first inside a with block."),Fn.forEach(t),fr=p(Te),At=n(Te,"P",{});var Hn=l(At);gr=r(Hn,"The other processes will enter the with block after the main process exits."),Hn.forEach(t),ur=p(Te),v(ce.$$.fragment,Te),Te.forEach(t),_r=p(S),W=n(S,"DIV",{class:!0});var Ze=l(W);v(qe.$$.fragment,Ze),$r=p(Ze),Ct=n(Ze,"P",{});var Jn=l(Ct);vr=r(Jn,"Decorator that only runs the decorated function on the last process."),Jn.forEach(t),br=p(Ze),v(ie.$$.fragment,Ze),Ze.forEach(t),Er=p(S),V=n(S,"DIV",{class:!0});var et=l(V);v(Ge.$$.fragment,et),wr=p(et),It=n(et,"P",{});var Kn=l(It);yr=r(Kn,"Decorator that only runs the decorated function on the local main process."),Kn.forEach(t),xr=p(et),v(pe.$$.fragment,et),et.forEach(t),jr=p(S),z=n(S,"DIV",{class:!0});var tt=l(z);v(Re.$$.fragment,tt),Sr=p(tt),Nt=n(tt,"P",{});var Qn=l(Nt);Pr=r(Qn,"Decorator that only runs the decorated function on the process with the given index on the current node."),Qn.forEach(t),Tr=p(tt),v(he.$$.fragment,tt),tt.forEach(t),kr=p(S),U=n(S,"DIV",{class:!0});var st=l(U);v(We.$$.fragment,st),Dr=p(st),qt=n(st,"P",{});var Xn=l(qt);Or=r(Xn,"Decorator that only runs the decorated function on the main process."),Xn.forEach(t),Lr=p(st),v(de.$$.fragment,st),st.forEach(t),Ar=p(S),B=n(S,"DIV",{class:!0});var at=l(B);v(Ve.$$.fragment,at),Cr=p(at),Gt=n(at,"P",{});var Yn=l(Gt);Ir=r(Yn,"Decorator that only runs the decorated function on the process with the given index."),Yn.forEach(t),Nr=p(at),v(me.$$.fragment,at),at.forEach(t),qr=p(S),M=n(S,"DIV",{class:!0});var rt=l(M);v(ze.$$.fragment,rt),Gr=p(rt),Rt=n(rt,"P",{});var Zn=l(Rt);Rr=r(Zn,`Will stop the execution of the current process until every other process has reached that point (so this does
nothing when the script is only run in one process). Useful to do before saving a model.`),Zn.forEach(t),Wr=p(rt),v(fe.$$.fragment,rt),rt.forEach(t),S.forEach(t),Ys=p(c),A=n(c,"DIV",{class:!0});var R=l(A);v(Ue.$$.fragment,R),Vr=p(R),Wt=n(R,"P",{});var el=l(Wt);zr=r(el,"Singleton class that has information about the current training environment."),el.forEach(t),Ur=p(R),Vt=n(R,"P",{});var tl=l(Vt);zt=n(tl,"STRONG",{});var sl=l(zt);Br=r(sl,"Available attributes:"),sl.forEach(t),tl.forEach(t),Mr=p(R),P=n(R,"UL",{});var D=l(P);ge=n(D,"LI",{});var qs=l(ge);Ut=n(qs,"STRONG",{});var al=l(Ut);Fr=r(al,"device"),al.forEach(t),Hr=r(qs," ("),Bt=n(qs,"CODE",{});var rl=l(Bt);Jr=r(rl,"torch.device"),rl.forEach(t),Kr=r(qs,") \u2014 The device to use."),qs.forEach(t),Qr=p(D),ue=n(D,"LI",{});var Gs=l(ue);Mt=n(Gs,"STRONG",{});var ol=l(Mt);Xr=r(ol,"distributed_type"),ol.forEach(t),Yr=r(Gs," ("),Xe=n(Gs,"A",{href:!0});var nl=l(Xe);Zr=r(nl,"DistributedType"),nl.forEach(t),eo=r(Gs,`) \u2014 The type of distributed environment currently
in use.`),Gs.forEach(t),to=p(D),G=n(D,"LI",{});var Q=l(G);Ft=n(Q,"STRONG",{});var ll=l(Ft);so=r(ll,"initialized"),ll.forEach(t),ao=r(Q," ("),Ht=n(Q,"CODE",{});var cl=l(Ht);ro=r(cl,"bool"),cl.forEach(t),oo=r(Q,") \u2014 Whether or not the "),Jt=n(Q,"CODE",{});var il=l(Jt);no=r(il,"AcceleratorState"),il.forEach(t),lo=r(Q," has been initialized from "),Kt=n(Q,"CODE",{});var pl=l(Kt);co=r(pl,"Accelerator"),pl.forEach(t),io=r(Q,"."),Q.forEach(t),po=p(D),_e=n(D,"LI",{});var Rs=l(_e);Qt=n(Rs,"STRONG",{});var hl=l(Qt);ho=r(hl,"local_process_index"),hl.forEach(t),mo=r(Rs," ("),Xt=n(Rs,"CODE",{});var dl=l(Xt);fo=r(dl,"int"),dl.forEach(t),go=r(Rs,") \u2014 The index of the current process on the current server."),Rs.forEach(t),uo=p(D),$e=n(D,"LI",{});var Ws=l($e);Yt=n(Ws,"STRONG",{});var ml=l(Yt);_o=r(ml,"mixed_precision"),ml.forEach(t),$o=r(Ws," ("),Zt=n(Ws,"CODE",{});var fl=l(Zt);vo=r(fl,"str"),fl.forEach(t),bo=r(Ws,`) \u2014 Whether or not the current script will use mixed precision, and if so the type
of mixed precision being performed.`),Ws.forEach(t),Eo=p(D),ve=n(D,"LI",{});var Vs=l(ve);es=n(Vs,"STRONG",{});var gl=l(es);wo=r(gl,"num_processes"),gl.forEach(t),yo=r(Vs," ("),ts=n(Vs,"CODE",{});var ul=l(ts);xo=r(ul,"int"),ul.forEach(t),jo=r(Vs,") \u2014 The number of processes currently launched in parallel."),Vs.forEach(t),So=p(D),be=n(D,"LI",{});var zs=l(be);ss=n(zs,"STRONG",{});var _l=l(ss);Po=r(_l,"process_index"),_l.forEach(t),To=r(zs," ("),as=n(zs,"CODE",{});var $l=l(as);ko=r($l,"int"),$l.forEach(t),Do=r(zs,") \u2014 The index of the current process."),zs.forEach(t),Oo=p(D),Ee=n(D,"LI",{});var Us=l(Ee);rs=n(Us,"STRONG",{});var vl=l(rs);Lo=r(vl,"is_last_process"),vl.forEach(t),Ao=r(Us," ("),os=n(Us,"CODE",{});var bl=l(os);Co=r(bl,"bool"),bl.forEach(t),Io=r(Us,") \u2014 Whether or not the current process is the last one."),Us.forEach(t),No=p(D),we=n(D,"LI",{});var Bs=l(we);ns=n(Bs,"STRONG",{});var El=l(ns);qo=r(El,"is_main_process"),El.forEach(t),Go=r(Bs," ("),ls=n(Bs,"CODE",{});var wl=l(ls);Ro=r(wl,"bool"),wl.forEach(t),Wo=r(Bs,") \u2014 Whether or not the current process is the main one."),Bs.forEach(t),Vo=p(D),ye=n(D,"LI",{});var Ms=l(ye);cs=n(Ms,"STRONG",{});var yl=l(cs);zo=r(yl,"is_local_main_process"),yl.forEach(t),Uo=r(Ms," ("),is=n(Ms,"CODE",{});var xl=l(is);Bo=r(xl,"bool"),xl.forEach(t),Mo=r(Ms,") \u2014 Whether or not the current process is the main one on the local node."),Ms.forEach(t),D.forEach(t),Fo=p(R),F=n(R,"DIV",{class:!0});var ot=l(F);v(Be.$$.fragment,ot),Ho=p(ot),ps=n(ot,"P",{});var jl=l(ps);Jo=r(jl,"Lets the local main process go inside a with block."),jl.forEach(t),Ko=p(ot),hs=n(ot,"P",{});var Sl=l(hs);Qo=r(Sl,"The other processes will enter the with block after the main process exits."),Sl.forEach(t),ot.forEach(t),Xo=p(R),H=n(R,"DIV",{class:!0});var nt=l(H);v(Me.$$.fragment,nt),Yo=p(nt),ds=n(nt,"P",{});var Pl=l(ds);Zo=r(Pl,"Lets the main process go first inside a with block."),Pl.forEach(t),en=p(nt),ms=n(nt,"P",{});var Tl=l(ms);tn=r(Tl,"The other processes will enter the with block after the main process exits."),Tl.forEach(t),nt.forEach(t),R.forEach(t),Zs=p(c),C=n(c,"DIV",{class:!0});var ke=l(C);v(Fe.$$.fragment,ke),sn=p(ke),fs=n(ke,"P",{});var kl=l(fs);an=r(kl,"Singleton class that has information related to gradient synchronization for gradient accumulation"),kl.forEach(t),rn=p(ke),gs=n(ke,"P",{});var Dl=l(gs);us=n(Dl,"STRONG",{});var Ol=l(us);on=r(Ol,"Available attributes:"),Ol.forEach(t),Dl.forEach(t),nn=p(ke),K=n(ke,"UL",{});var lt=l(K);xe=n(lt,"LI",{});var Fs=l(xe);_s=n(Fs,"STRONG",{});var Ll=l(_s);ln=r(Ll,"end_of_dataloader"),Ll.forEach(t),cn=r(Fs," ("),$s=n(Fs,"CODE",{});var Al=l($s);pn=r(Al,"bool"),Al.forEach(t),hn=r(Fs,") \u2014 Whether we have reached the end the current dataloader"),Fs.forEach(t),dn=p(lt),je=n(lt,"LI",{});var Hs=l(je);vs=n(Hs,"STRONG",{});var Cl=l(vs);mn=r(Cl,"remainder"),Cl.forEach(t),fn=r(Hs," ("),bs=n(Hs,"CODE",{});var Il=l(bs);gn=r(Il,"int"),Il.forEach(t),un=r(Hs,") \u2014 The number of extra samples that were added from padding the dataloader"),Hs.forEach(t),_n=p(lt),Se=n(lt,"LI",{});var Js=l(Se);Es=n(Js,"STRONG",{});var Nl=l(Es);$n=r(Nl,"sync_gradients"),Nl.forEach(t),vn=r(Js," ("),ws=n(Js,"CODE",{});var ql=l(ws);bn=r(ql,"bool"),ql.forEach(t),En=r(Js,") \u2014 Whether the gradients should be synced across all devices"),Js.forEach(t),lt.forEach(t),ke.forEach(t),this.h()},h(){T(d,"name","hf:doc:metadata"),T(d,"content",JSON.stringify(Zl)),T(h,"id","accelerate.PartialState"),T(h,"class","header-link block pr-1.5 text-lg no-hover:hidden with-hover:absolute with-hover:p-1.5 with-hover:opacity-0 with-hover:group-hover:opacity-100 with-hover:right-full"),T(h,"href","#accelerate.PartialState"),T(f,"class","relative group"),T(Ae,"href","https://en.wikipedia.org/wiki/Singleton_pattern"),T(Ae,"rel","nofollow"),T(Qe,"href","/docs/accelerate/v0.17.0/en/package_reference/utilities#accelerate.DistributedType"),T(N,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(q,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(W,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(V,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(z,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(U,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(B,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(M,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(x,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(Xe,"href","/docs/accelerate/v0.17.0/en/package_reference/utilities#accelerate.DistributedType"),T(F,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(H,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(A,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8"),T(C,"class","docstring border-l-2 border-t-2 pl-4 pt-3.5 border-gray-100 rounded-tl-xl mb-6 mt-8")},m(c,_){e(document.head,d),j(c,u,_),j(c,f,_),e(f,h),e(h,g),b(s,g,null),e(f,m),e(f,ct),e(ct,ta),j(c,Ks,_),j(c,X,_),e(X,sa),e(X,Ae),e(Ae,aa),e(X,ra),j(c,Qs,_),j(c,Ke,_),e(Ke,oa),j(c,Xs,_),j(c,x,_),b(Ce,x,null),e(x,na),e(x,J),e(J,la),e(J,it),e(it,ca),e(J,ia),e(J,pt),e(pt,pa),e(J,ha),e(x,da),e(x,ht),e(ht,dt),e(dt,ma),e(x,fa),e(x,k),e(k,Y),e(Y,mt),e(mt,ga),e(Y,ua),e(Y,ft),e(ft,_a),e(Y,$a),e(k,va),e(k,Z),e(Z,gt),e(gt,ba),e(Z,Ea),e(Z,Qe),e(Qe,wa),e(Z,ya),e(k,xa),e(k,ee),e(ee,ut),e(ut,ja),e(ee,Sa),e(ee,_t),e(_t,Pa),e(ee,Ta),e(k,ka),e(k,te),e(te,$t),e($t,Da),e(te,Oa),e(te,vt),e(vt,La),e(te,Aa),e(k,Ca),e(k,se),e(se,bt),e(bt,Ia),e(se,Na),e(se,Et),e(Et,qa),e(se,Ga),e(k,Ra),e(k,ae),e(ae,wt),e(wt,Wa),e(ae,Va),e(ae,yt),e(yt,za),e(ae,Ua),e(k,Ba),e(k,re),e(re,xt),e(xt,Ma),e(re,Fa),e(re,jt),e(jt,Ha),e(re,Ja),e(k,Ka),e(k,oe),e(oe,St),e(St,Qa),e(oe,Xa),e(oe,Pt),e(Pt,Ya),e(oe,Za),e(k,er),e(k,ne),e(ne,Tt),e(Tt,tr),e(ne,sr),e(ne,kt),e(kt,ar),e(ne,rr),e(x,or),e(x,N),b(Ie,N,null),e(N,nr),e(N,Dt),e(Dt,lr),e(N,cr),e(N,Ot),e(Ot,ir),e(N,pr),b(le,N,null),e(x,hr),e(x,q),b(Ne,q,null),e(q,dr),e(q,Lt),e(Lt,mr),e(q,fr),e(q,At),e(At,gr),e(q,ur),b(ce,q,null),e(x,_r),e(x,W),b(qe,W,null),e(W,$r),e(W,Ct),e(Ct,vr),e(W,br),b(ie,W,null),e(x,Er),e(x,V),b(Ge,V,null),e(V,wr),e(V,It),e(It,yr),e(V,xr),b(pe,V,null),e(x,jr),e(x,z),b(Re,z,null),e(z,Sr),e(z,Nt),e(Nt,Pr),e(z,Tr),b(he,z,null),e(x,kr),e(x,U),b(We,U,null),e(U,Dr),e(U,qt),e(qt,Or),e(U,Lr),b(de,U,null),e(x,Ar),e(x,B),b(Ve,B,null),e(B,Cr),e(B,Gt),e(Gt,Ir),e(B,Nr),b(me,B,null),e(x,qr),e(x,M),b(ze,M,null),e(M,Gr),e(M,Rt),e(Rt,Rr),e(M,Wr),b(fe,M,null),j(c,Ys,_),j(c,A,_),b(Ue,A,null),e(A,Vr),e(A,Wt),e(Wt,zr),e(A,Ur),e(A,Vt),e(Vt,zt),e(zt,Br),e(A,Mr),e(A,P),e(P,ge),e(ge,Ut),e(Ut,Fr),e(ge,Hr),e(ge,Bt),e(Bt,Jr),e(ge,Kr),e(P,Qr),e(P,ue),e(ue,Mt),e(Mt,Xr),e(ue,Yr),e(ue,Xe),e(Xe,Zr),e(ue,eo),e(P,to),e(P,G),e(G,Ft),e(Ft,so),e(G,ao),e(G,Ht),e(Ht,ro),e(G,oo),e(G,Jt),e(Jt,no),e(G,lo),e(G,Kt),e(Kt,co),e(G,io),e(P,po),e(P,_e),e(_e,Qt),e(Qt,ho),e(_e,mo),e(_e,Xt),e(Xt,fo),e(_e,go),e(P,uo),e(P,$e),e($e,Yt),e(Yt,_o),e($e,$o),e($e,Zt),e(Zt,vo),e($e,bo),e(P,Eo),e(P,ve),e(ve,es),e(es,wo),e(ve,yo),e(ve,ts),e(ts,xo),e(ve,jo),e(P,So),e(P,be),e(be,ss),e(ss,Po),e(be,To),e(be,as),e(as,ko),e(be,Do),e(P,Oo),e(P,Ee),e(Ee,rs),e(rs,Lo),e(Ee,Ao),e(Ee,os),e(os,Co),e(Ee,Io),e(P,No),e(P,we),e(we,ns),e(ns,qo),e(we,Go),e(we,ls),e(ls,Ro),e(we,Wo),e(P,Vo),e(P,ye),e(ye,cs),e(cs,zo),e(ye,Uo),e(ye,is),e(is,Bo),e(ye,Mo),e(A,Fo),e(A,F),b(Be,F,null),e(F,Ho),e(F,ps),e(ps,Jo),e(F,Ko),e(F,hs),e(hs,Qo),e(A,Xo),e(A,H),b(Me,H,null),e(H,Yo),e(H,ds),e(ds,Zo),e(H,en),e(H,ms),e(ms,tn),j(c,Zs,_),j(c,C,_),b(Fe,C,null),e(C,sn),e(C,fs),e(fs,an),e(C,rn),e(C,gs),e(gs,us),e(us,on),e(C,nn),e(C,K),e(K,xe),e(xe,_s),e(_s,ln),e(xe,cn),e(xe,$s),e($s,pn),e(xe,hn),e(K,dn),e(K,je),e(je,vs),e(vs,mn),e(je,fn),e(je,bs),e(bs,gn),e(je,un),e(K,_n),e(K,Se),e(Se,Es),e(Es,$n),e(Se,vn),e(Se,ws),e(ws,bn),e(Se,En),ea=!0},p(c,[_]){const He={};_&2&&(He.$$scope={dirty:_,ctx:c}),le.$set(He);const ys={};_&2&&(ys.$$scope={dirty:_,ctx:c}),ce.$set(ys);const xs={};_&2&&(xs.$$scope={dirty:_,ctx:c}),ie.$set(xs);const js={};_&2&&(js.$$scope={dirty:_,ctx:c}),pe.$set(js);const Je={};_&2&&(Je.$$scope={dirty:_,ctx:c}),he.$set(Je);const Ss={};_&2&&(Ss.$$scope={dirty:_,ctx:c}),de.$set(Ss);const Ps={};_&2&&(Ps.$$scope={dirty:_,ctx:c}),me.$set(Ps);const S={};_&2&&(S.$$scope={dirty:_,ctx:c}),fe.$set(S)},i(c){ea||(E(s.$$.fragment,c),E(Ce.$$.fragment,c),E(Ie.$$.fragment,c),E(le.$$.fragment,c),E(Ne.$$.fragment,c),E(ce.$$.fragment,c),E(qe.$$.fragment,c),E(ie.$$.fragment,c),E(Ge.$$.fragment,c),E(pe.$$.fragment,c),E(Re.$$.fragment,c),E(he.$$.fragment,c),E(We.$$.fragment,c),E(de.$$.fragment,c),E(Ve.$$.fragment,c),E(me.$$.fragment,c),E(ze.$$.fragment,c),E(fe.$$.fragment,c),E(Ue.$$.fragment,c),E(Be.$$.fragment,c),E(Me.$$.fragment,c),E(Fe.$$.fragment,c),ea=!0)},o(c){w(s.$$.fragment,c),w(Ce.$$.fragment,c),w(Ie.$$.fragment,c),w(le.$$.fragment,c),w(Ne.$$.fragment,c),w(ce.$$.fragment,c),w(qe.$$.fragment,c),w(ie.$$.fragment,c),w(Ge.$$.fragment,c),w(pe.$$.fragment,c),w(Re.$$.fragment,c),w(he.$$.fragment,c),w(We.$$.fragment,c),w(de.$$.fragment,c),w(Ve.$$.fragment,c),w(me.$$.fragment,c),w(ze.$$.fragment,c),w(fe.$$.fragment,c),w(Ue.$$.fragment,c),w(Be.$$.fragment,c),w(Me.$$.fragment,c),w(Fe.$$.fragment,c),ea=!1},d(c){t(d),c&&t(u),c&&t(f),y(s),c&&t(Ks),c&&t(X),c&&t(Qs),c&&t(Ke),c&&t(Xs),c&&t(x),y(Ce),y(Ie),y(le),y(Ne),y(ce),y(qe),y(ie),y(Ge),y(pe),y(Re),y(he),y(We),y(de),y(Ve),y(me),y(ze),y(fe),c&&t(Ys),c&&t(A),y(Ue),y(Be),y(Me),c&&t(Zs),c&&t(C),y(Fe)}}}const Zl={local:"accelerate.PartialState",title:"Stateful Classes"};function ec(O){return zl(()=>{new URLSearchParams(window.location.search).get("fw")}),[]}class nc extends Gl{constructor(d){super();Rl(this,d,ec,Yl,Wl,{})}}export{nc as default,Zl as metadata};
